from fovus.constants.cli_constants import (
    MAX_GPU,
    MAX_VCPU,
    MIN_GPU,
    MIN_GPU_MEM_GIB,
    MIN_VCPU,
    MIN_VCPU_MEM_GIB,
    PARALLELISM_OPTIMIZATION,
    SCALABLE_PARALLELISM,
)

BOUNDS = "bounds"
CORRECTABLE_COMPARISON = "correctable_comparison"
CORRECTABLE_LIST_COMPREHENSION = "correctable_list_comprehension"
INCORRECTABLE_COMPARISON = "incorrectable_comparison"
INCORRECTABLE_LIST_COMPREHENSION = "incorrectable_list_comprehension"

BENCHMARK_NAME = "benchmarkName"
LIST_BENCHMARKING_FIELD_BY_CREATE_JOB_REQUEST_FIELD = {
    MIN_VCPU: "cpuRange",
    MAX_VCPU: "cpuRange",
    MIN_VCPU_MEM_GIB: "cpuMemoryRange",
    MIN_GPU: "gpuRange",
    MAX_GPU: "gpuRange",
    MIN_GPU_MEM_GIB: "gpuMemoryRange",
    SCALABLE_PARALLELISM: "scalableParallelism",
    PARALLELISM_OPTIMIZATION: "parallelismOptimization",
}

COMPARISONS = [INCORRECTABLE_COMPARISON, CORRECTABLE_COMPARISON]
COMPREHENSIONS = [INCORRECTABLE_LIST_COMPREHENSION, CORRECTABLE_LIST_COMPREHENSION]

DEFAULT_LOWER_BOUNDS_TO_VALIDATE = [MIN_VCPU, MIN_VCPU_MEM_GIB]
DEFAULT_UPPER_BOUNDS_TO_VALIDATE = [MAX_VCPU]
DEFAULT_BOOLEANS_TO_VALIDATE = [SCALABLE_PARALLELISM, PARALLELISM_OPTIMIZATION]

GPU_LOWER_BOUNDS_TO_VALIDATE = [MIN_GPU, MIN_GPU_MEM_GIB]
GPU_UPPER_BOUNDS_TO_VALIDATE = [MAX_GPU]
